
function drawLinkedNodeRaphaelCurver1(canID, paper, nodeLevel, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, color, widthB, heightB) {

    var text = "curvePath";
    var py = Math.abs(ly - my) / 2;
    var weight = widthB * 0.003125;
    switch (parseInt(nodeLevel)) {
        case 1: weight = widthB * 0.00625; break;
        case 2: weight = widthB * 0.0046875; break;
        case 3: weight = widthB * 0.003125; break;
    }
    if (ct1x != null && ct2x != null) {
        var text = paper.path("M" + mx + "," + my + " C" + ct1x + "," + ct1y + " " + ct2x + "," + ct2y + " " + lx + "," + ly + "");
    } else {
        py = Math.abs(lx - mx) / 6;
        var text = paper.path("M" + mx + "," + my + " L" + lx + "," + ly + "");
    }
    text.attr({ "stroke-width": "" + parseInt(weight) + "", "stroke": color, "stroke-linecap": "round" });
    drawCircle(canID, lx, ly, parseInt(weight / 2), color, 0, color);
}
function drawLineRapheal(canID, paper, mx, my, lx, ly, color, weight) {
    var text = paper.path("M" + mx + "," + my + " L" + lx + "," + ly + "");
    text.attr({ "stroke-width": "" + parseFloat(weight) + "", "stroke": color, "stroke-linecap": "round" });
}
function drawLinkedLink(content, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, color, widthB) {
    var text = "curvePath";
    var py = Math.abs(ly - my) / 2;
    var weight = widthB * 0.0025;
    if (ct1x != null && ct2x != null) {
        var text = paper.path("M" + mx + "," + my + " C" + ct1x + "," + ct1y + " " + ct2x + "," + ct2y + " " + lx + "," + ly + "");
    } else {
        py = Math.abs(lx - mx) / 6;
        var text = paper.path("M" + mx + "," + my + " L" + lx + "," + ly + "");
    }
    if (color == "") {
        color = "black";
    }
    text.attr({ "stroke-width": "" + parseInt(weight) + "", "stroke": color, "stroke-dasharray": "-" });
}

function draw_LinkedNode_RaphaelPath_3(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor) {

    mx = parseFloat(mx); my = parseFloat(my);
    ct1x = parseFloat(ct1x); ct1y = parseFloat(ct1y);
    ct2x = parseFloat(ct2x); ct2y = parseFloat(ct2y);
    lx = parseFloat(lx); ly = parseFloat(ly);
    var _tan = Math.abs(lx - mx) / Math.abs(ly - my);
    var _tan1 = Math.abs(ct1x - mx) / Math.abs(ct1y - my);
    var _tan2 = Math.abs(ct1x - ct2x) / Math.abs(ct1y - ct2y);
    var _tanEnd = Math.abs(lx - ct2x) / Math.abs(ly - ct2y);

    var diem1x, diem1y, diem11x, diem11y;
    var diem2x, diem2y, diem22x, diem22y;
    var diem3x, diem3y, diem33x, diem33y;
    var diem4x, diem4y, diem44x, diem44y;
    if (_tan1 > 1) {
        diem1x = mx;
        diem1y = my - weight * 0.5;
        diem2x = ct1x;
        diem2x = ct1y - weight * 0.4;
        diem11x = mx;
        diem11y = my + weight * 0.5;
        diem22x = ct1x;
        diem22y = ct1y + weight * 0.4;
    } else {
        diem1x = mx - weight * 0.5;
        diem1y = my;
        diem2x = ct1x - weight * 0.4;
        diem2x = ct1y;
        diem11x = mx + weight * 0.5;
        diem11y = my;
        diem22x = ct1x + weight * 0.4;
        diem22y = ct1y;
    }
    if (_tan1 > 1) {
        if (_tan > 1) {
            if (ct1x > mx) {
                var Ccc = paper.path("M" + diem1x + "," + (diem1y) + " C" + (ct1x) + "," + (ct1y - weight * 0.4) + " " + (ct2x) + "," + (ct2y - endweight * 0.6) + " " + lx + "," + (ly - endweight * 0.5) + " L" + lx + "," + (ly + endweight * 0.5) + " C" + (ct2x) + "," + (ct2y + endweight * 0.6) + " " + (ct1x) + "," + (ct1y + weight * 0.4) + " " + diem11x + "," + (diem11y) + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });


            } else if (ct1x < mx) {
                var Ccc = paper.path("M" + diem1x + "," + (diem1y) + " C" + (ct1x) + "," + (ct1y - weight * 0.4) + " " + (ct2x) + "," + (ct2y - endweight * 0.6) + " " + lx + "," + (ly - endweight * 0.5) + " L" + lx + "," + (ly + endweight * 0.5) + " C" + (ct2x) + "," + (ct2y + endweight * 0.6) + " " + (ct1x) + "," + (ct1y + weight * 0.4) + " " + diem11x + "," + (diem11y) + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });


            }
            else {
                var Ccc = paper.path("M" + mx + "," + (my - weight * 0.5) + " C" + (ct1x) + "," + (ct1y - weight * 0.4) + " " + (ct2x) + "," + (ct2y - endweight * 0.6) + " " + lx + "," + (ly - endweight * 0.5) + " L" + lx + "," + (ly + endweight * 0.5) + " C" + (ct2x) + "," + (ct2y + endweight * 0.6) + " " + (ct1x) + "," + (ct1y + weight * 0.4) + " " + mx + "," + (my + weight * 0.5) + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });
            }
        }
        else {
            if (ct1x > mx) {
                var Ccc = paper.path("M" + (diem11x) + "," + diem11y + " C" + (ct1x - weight * 0.4) + "," + (ct1y) + " " + (ct2x - endweight * 0.6) + "," + (ct2y) + " " + (lx - endweight * 0.5) + "," + ly + " L" + (lx + endweight * 0.5) + "," + ly + " C" + (ct2x + endweight * 0.6) + "," + (ct2y) + " " + (ct1x + weight * 0.4) + "," + (ct1y) + " " + (diem1x) + "," + diem1y + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });

            }
            else if (ct1x < mx) {
                var Ccc = paper.path("M" + (diem1x) + "," + diem1y + " C" + (ct1x - weight * 0.4) + "," + (ct1y) + " " + (ct2x - endweight * 0.6) + "," + (ct2y) + " " + (lx - endweight * 0.5) + "," + ly + " L" + (lx + endweight * 0.5) + "," + ly + " C" + (ct2x + endweight * 0.6) + "," + (ct2y) + " " + (ct1x + weight * 0.4) + "," + (ct1y) + " " + (diem11x) + "," + diem11y + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });

            }
            else {
                var Ccc = paper.path("M" + (mx - weight * 0.5) + "," + my + " C" + (ct1x - weight * 0.4) + "," + (ct1y) + " " + (ct2x - endweight * 0.6) + "," + (ct2y) + " " + (lx - endweight * 0.5) + "," + ly + " L" + (lx + endweight * 0.5) + "," + ly + " C" + (ct2x + endweight * 0.6) + "," + (ct2y) + " " + (ct1x + weight * 0.4) + "," + (ct1y) + " " + (mx + weight * 0.5) + "," + my + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });
            }
        }
    }
    else {
        if (_tan > 1) {
            if (ct1x > mx) {
                var Ccc = paper.path("M" + diem11x + "," + (diem11y) + " C" + (ct1x) + "," + (ct1y - weight * 0.4) + " " + (ct2x) + "," + (ct2y - endweight * 0.6) + " " + lx + "," + (ly - endweight * 0.5) + " L" + lx + "," + (ly + endweight * 0.5) + " C" + (ct2x) + "," + (ct2y + endweight * 0.6) + " " + (ct1x) + "," + (ct1y + weight * 0.4) + " " + diem1x + "," + (diem1y) + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });

            } else if (ct1x < mx) {
                var Ccc = paper.path("M" + diem11x + "," + (diem11y) + " C" + (ct1x) + "," + (ct1y - weight * 0.4) + " " + (ct2x) + "," + (ct2y - endweight * 0.6) + " " + lx + "," + (ly - endweight * 0.5) + " L" + lx + "," + (ly + endweight * 0.5) + " C" + (ct2x) + "," + (ct2y + endweight * 0.6) + " " + (ct1x) + "," + (ct1y + weight * 0.4) + " " + diem1x + "," + (diem1y) + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });
            }
            else {
                var Ccc = paper.path("M" + mx + "," + (my - weight * 0.5) + " C" + (ct1x) + "," + (ct1y - weight * 0.4) + " " + (ct2x) + "," + (ct2y - endweight * 0.6) + " " + lx + "," + (ly - endweight * 0.5) + " L" + lx + "," + (ly + endweight * 0.5) + " C" + (ct2x) + "," + (ct2y + endweight * 0.6) + " " + (ct1x) + "," + (ct1y + weight * 0.4) + " " + mx + "," + (my + weight * 0.5) + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });
            }
        }
        else {
            if (ct1x > mx) {
                var Ccc = paper.path("M" + (diem1x) + "," + diem1y + " C" + (ct1x - weight * 0.4) + "," + (ct1y) + " " + (ct2x - endweight * 0.6) + "," + (ct2y) + " " + (lx - endweight * 0.5) + "," + ly + " L" + (lx + endweight * 0.5) + "," + ly + " C" + (ct2x + endweight * 0.6) + "," + (ct2y) + " " + (ct1x + weight * 0.4) + "," + (ct1y) + " " + (diem11x) + "," + diem11y + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });

            }
            else if (ct1x < mx) {
                var Ccc = paper.path("M" + (diem1x) + "," + diem1y + " C" + (ct1x - weight * 0.4) + "," + (ct1y) + " " + (ct2x - endweight * 0.6) + "," + (ct2y) + " " + (lx - endweight * 0.5) + "," + ly + " L" + (lx + endweight * 0.5) + "," + ly + " C" + (ct2x + endweight * 0.6) + "," + (ct2y) + " " + (ct1x + weight * 0.4) + "," + (ct1y) + " " + (diem11x) + "," + diem11y + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });

            }
            else {
                var Ccc = paper.path("M" + (mx - weight * 0.5) + "," + my + " C" + (ct1x - weight * 0.4) + "," + (ct1y) + " " + (ct2x - endweight * 0.6) + "," + (ct2y) + " " + (lx - endweight * 0.5) + "," + ly + " L" + (lx + endweight * 0.5) + "," + ly + " C" + (ct2x + endweight * 0.6) + "," + (ct2y) + " " + (ct1x + weight * 0.4) + "," + (ct1y) + " " + (mx + weight * 0.5) + "," + my + " z");
                Ccc.attr({ "stroke-width": "0", stroke: "Blue", 'fill': fillColor });
            }
        }
    }
    drawCircle(canID, lx, ly, parseInt(endweight / 2), fillColor, 0, fillColor);
}

function veDivContainerBranch(content, mx, lx, ly, color, CBHeight, CBWidth, widthB) {
    var gr1 = document.getElementById(content);
    var element = document.createElement('div');
    text1 = "DivContainerBranch" + parseInt(lx) + "" + parseInt(ly);
    element.id = text1;
    gr1.appendChild(element);
    var top, left;
    if (lx >= mx) {
        left = lx;
        top = ly - (parseInt(CBHeight) / 2);
    } else {
        left = lx - CBWidth;
        top = ly - (parseInt(CBHeight) / 2);
    }
    var divCbr = document.getElementById(text1);
    divCbr.style.top = top + "px";
    divCbr.style.left = left + "px";
    divCbr.style.height = CBHeight + "px";
    divCbr.style.width = CBWidth + "px";
    divCbr.style.position = "absolute";
    divCbr.style.backgroundColor = "white";
    var bd1 = widthB * (4 / 800);
    var bd2 = widthB * (2 / 800);
    divCbr.style.borderTopWidth = parseInt(bd1) + "px";
    divCbr.style.borderLeftWidth = parseInt(bd1) + "px";
    divCbr.style.borderRightWidth = parseInt(bd2) + "px";
    divCbr.style.borderBottomWidth = parseInt(bd2) + "px";
    divCbr.style.borderStyle = "solid";
    divCbr.style.borderColor = color;
    divCbr.style.borderRadius = widthB * (5 / 800) + "px";
    document.getElementById(text1).style.zIndex = '8';

}

function draw_LinkedNode_RaphaelPath_4(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB) {
    var version = checkVersionIE();
    mx = parseFloat(mx); my = parseFloat(my);
    ct1x = parseFloat(ct1x); ct1y = parseFloat(ct1y);
    ct2x = parseFloat(ct2x); ct2y = parseFloat(ct2y);
    lx = parseFloat(lx); ly = parseFloat(ly);
    var _tan = Math.abs(lx - mx) / Math.abs(ly - my);
    var checkx = 0;
    var checky = 0;
    var string1 = "M" + mx + "," + my + " C" + ct1x + "," + ct1y + " " + ct2x + "," + ct2y + " " + lx + "," + ly + "";

    if (version > 8 || version == 0) {
        if (Math.abs(lx - mx) >= Math.abs(ly - my)) {
            if (lx > mx) {

                VeXlon(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB);

            } else {
                VeXnho(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB);
            }
        } else if (Math.abs(lx - mx) < Math.abs(ly - my)) {
            if (ly > my) {
                VeYlon(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB);
            }
            else {
                VeYnho(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB);
            }
        }
    } else {
        //draw_LinkedNode_RaphaelPath_3(canID,paper,mx,my,ct1x,ct1y,ct2x,ct2y,lx,ly,weight,endweight,fillColor);
        draw_LinkedNode_RaphaelPath_2(canID, paper, mx, my, lx, ly, weight, endweight, fillColor);
    }

}
function VeXlon(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB) {
    mx = parseInt(mx); my = parseInt(my);
    ct1x = parseInt(ct1x); ct1y = parseInt(ct1y);
    ct2x = parseInt(ct2x); ct2y = parseInt(ct2y);
    lx = parseInt(lx); ly = parseInt(ly);
    var string1 = "M" + mx + "," + my + " C" + ct1x + "," + ct1y + " " + ct2x + "," + ct2y + " " + lx + "," + ly + "";
    var tile = (weight - (endweight));
    var kt1 = parseInt(Math.abs(lx - mx) / 3);
    var arrDiem = [{}];
    for (i = mx; i <= lx; i++) {
        points = Raphael.pathIntersection(string1, "M" + i + "," + 0 + " L" + i + "," + heightB + "");
        if (points.length == 1) {
            var obj = {};
            obj.x = points[0].x;
            obj.y = points[0].y;
            arrDiem.push(obj);
        }
        else {
			if(points.length>0)
			{
				if (parseInt(points[0].y) < parseInt(points[1].y)) {
					for (j = parseInt(points[0].y); j <= parseInt(points[1].y); j++) {
						points2 = Raphael.pathIntersection(string1, "M" + 0 + "," + j + " L" + widthB + "," + j + "");
						if (points2.length > 0) {
							var obj = {};
							obj.x = points2[0].x;
							obj.y = points2[0].y;
							arrDiem.push(obj);
						}
					}
				} else {
					for (j = parseInt(points[0].y); j >= parseInt(points[1].y); j--) {
						points2 = Raphael.pathIntersection(string1, "M" + 0 + "," + j + " L" + widthB + "," + j + "");
						if (points2.length > 0) {
							var obj = {};
							obj.x = points2[0].x;
							obj.y = points2[0].y;
							arrDiem.push(obj);
						}
					}
				}
			}
        }
        if (i == lx) {
            for (k = 0; k <= arrDiem.length; k++) {
                if (k < arrDiem.length - 1) {
                    var dolon = (k) * (tile / (arrDiem.length));
                    drawLineRapheal(canID, paper, arrDiem[k].x, arrDiem[k].y, arrDiem[k + 1].x, arrDiem[k + 1].y, fillColor, weight - dolon);
                }
            }
        }
    }
}
function VeXnho(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB) {
    mx = parseInt(mx); my = parseInt(my);
    ct1x = parseInt(ct1x); ct1y = parseInt(ct1y);
    ct2x = parseInt(ct2x); ct2y = parseInt(ct2y);
    lx = parseInt(lx); ly = parseInt(ly);
    var string1 = "M" + mx + "," + my + " C" + ct1x + "," + ct1y + " " + ct2x + "," + ct2y + " " + lx + "," + ly + "";
    var tile = (weight - (endweight));
    var kt1 = parseInt(Math.abs(lx - mx) / 3);
    var arrDiem = [{}];

    for (i = mx; i >= lx; i--) {
        points = Raphael.pathIntersection(string1, "M" + i + "," + 0 + " L" + i + "," + heightB + "");
        if (points.length == 1) {
            var obj = {};
            obj.x = points[0].x;
            obj.y = points[0].y;
            arrDiem.push(obj);
        }
        else {
			if(points.length>0)
			{
				if (parseInt(points[0].y) < parseInt(points[1].y)) {
					for (j = parseInt(points[0].y); j <= parseInt(points[1].y); j++) {
						points2 = Raphael.pathIntersection(string1, "M" + 0 + "," + j + " L" + widthB + "," + j + "");
						if (points2.length > 0) {
							var obj = {};
							obj.x = points2[0].x;
							obj.y = points2[0].y;
							arrDiem.push(obj);
						}
					}
				} else {
					for (j = parseInt(points[0].y); j >= parseInt(points[1].y); j--) {
						points2 = Raphael.pathIntersection(string1, "M" + 0 + "," + j + " L" + widthB + "," + j + "");
						if (points2.length > 0) {
							var obj = {};
							obj.x = points2[0].x;
							obj.y = points2[0].y;
							arrDiem.push(obj);
						}
					}
				}
			}
        }
        if (i == lx) {
            for (k = 0; k <= arrDiem.length; k++) {
                if (k < arrDiem.length - 1) {
                    var dolon = (k) * (tile / (arrDiem.length));
                    drawLineRapheal(canID, paper, arrDiem[k].x, arrDiem[k].y, arrDiem[k + 1].x, arrDiem[k + 1].y, fillColor, weight - dolon);
                }
            }

        }
    }

}

function VeYlon(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB) {

    mx = parseInt(mx); my = parseInt(my);
    ct1x = parseInt(ct1x); ct1y = parseInt(ct1y);
    ct2x = parseInt(ct2x); ct2y = parseInt(ct2y);
    lx = parseInt(lx); ly = parseInt(ly);
    var string1 = "M" + mx + "," + my + " C" + ct1x + "," + ct1y + " " + ct2x + "," + ct2y + " " + lx + "," + ly + "";
    var tile = (weight - (endweight));
    var kt1 = parseInt(Math.abs(ly - my) / 3);
    var arrDiem = [{}];
    for (i = my; i <= ly; i++) {
        points = Raphael.pathIntersection(string1, "M" + 0 + "," + i + " L" + widthB + "," + i + "");
        if (points.length == 1) {
            var obj = {};
            obj.x = points[0].x;
            obj.y = points[0].y;
            arrDiem.push(obj);
        } else {
			if(points.length>0)
			{
				if (parseInt(points[0].x) < parseInt(points[1].x)) {
					for (j = parseInt(points[0].x); j <= parseInt(points[1].x); j++) {
						points2 = Raphael.pathIntersection(string1, "M" + j + "," + 0 + " L" + j + "," + heightB + "");
						if (points2.length > 0) {
							var obj = {};
							obj.x = points2[0].x;
							obj.y = points2[0].y;
							arrDiem.push(obj);
						}
					}
				} else {
					for (j = parseInt(points[0].x); j >= parseInt(points[1].x); j--) {
						points2 = Raphael.pathIntersection(string1, "M" + j + "," + 0 + " L" + j + "," + heightB + "");
						if (points2.length > 0) {
							var obj = {};
							obj.x = points2[0].x;
							obj.y = points2[0].y;
							arrDiem.push(obj);
						}
					}
				}
			}
        }

        if (i == (ly)) {
            for (k = 0; k <= arrDiem.length; k++) {
                if (k < arrDiem.length - 1) {
                    var dolon = (k) * (tile / (arrDiem.length));
                    drawLineRapheal(canID, paper, arrDiem[k].x, arrDiem[k].y, arrDiem[k + 1].x, arrDiem[k + 1].y, fillColor, weight - dolon);
                }
            }
        }

    }
}
function VeYnho(canID, paper, mx, my, ct1x, ct1y, ct2x, ct2y, lx, ly, weight, endweight, fillColor, widthB, heightB) {
    mx = parseInt(mx); my = parseInt(my);
    ct1x = parseInt(ct1x); ct1y = parseInt(ct1y);
    ct2x = parseInt(ct2x); ct2y = parseInt(ct2y);
    lx = parseInt(lx); ly = parseInt(ly);
    var string1 = "M" + mx + "," + my + " C" + ct1x + "," + ct1y + " " + ct2x + "," + ct2y + " " + lx + "," + ly + "";
    var tile = (weight - (endweight));
    var kt1 = parseInt(Math.abs(ly - my) / 3);
    var arrDiem = [{}];
    for (i = my; i >= ly; i--) {
        points = Raphael.pathIntersection(string1, "M" + 0 + "," + i + " L" + widthB + "," + i + "");
        if (i < my) {
            if (points.length == 1) {
                var obj = {};
                obj.x = points[0].x;
                obj.y = points[0].y;
                arrDiem.push(obj);

            } else {
				if(points.length>0)
				{
					if (parseInt(points[0].x) < parseInt(points[1].x)) {
						for (j = parseInt(points[0].x); j <= parseInt(points[1].x); j++) {
							points2 = Raphael.pathIntersection(string1, "M" + j + "," + 0 + " L" + j + "," + heightB + "");
							if (points2.length > 0) {
								var obj = {};
								obj.x = points2[0].x;
								obj.y = points2[0].y;
								arrDiem.push(obj);
							}
						}
					} else {
						for (j = points[0].x; j >= points[1].x; j--) {
							points2 = Raphael.pathIntersection(string1, "M" + j + "," + 0 + " L" + j + "," + heightB + "");
							if (points2.length > 0) {
								var obj = {};
								obj.x = points2[0].x;
								obj.y = points2[0].y;
								arrDiem.push(obj);
							}
						}
					}
            
				}
            }
        }
        if (i == ly) {
            for (k = 0; k <= arrDiem.length; k++) {
                if (k < arrDiem.length - 1) {
                    var dolon = (k) * (tile / (arrDiem.length));
                    drawLineRapheal(canID, paper, arrDiem[k].x, arrDiem[k].y, arrDiem[k + 1].x, arrDiem[k + 1].y, fillColor, weight - dolon);
                }
            }
        }
    } //alert(1);

}


	