/*
 * Author: Bigson
 * Email : bigson.hathanh@gmail.com
 * Version: 1.0.0
 * Date: 02 - 08 -2014
 */
(function ( $ ) {
	$.fn.slider = function(options) {
		var $this = this,
			sliderIsMove = false,
			sliderHL,
			sliderQT,
			sliderBar,
			content = '<div class="range-bar">\
		        	<div class="range-bg"></div>\
			        <div class="range-handle" style="left: 0;"></div>\
			        <div class="range-quantity" style="width: 0;"></div>\
		        </div>',
		    settings = $.extend({
		    	percent : 0,
		    	genTag : true,
		    	hlSelecter : '.range-handle',
		    	qtSelecter : '.range-quantity',
		    	barSelecter : '.range-bar',
		    	bgSelecter : '.range-bg',
		    	cssHL : {
			    		'background-color': '#fff',
						'border-radius': '100%',
						'cursor': 'pointer',
						'height': '10px',
						'width': '10px',
						'left': '0',
						'top': '50%',
						'position': 'absolute',
						'z-index': '51',
						'margin-top': '-5px',
						'margin-left': '-5px',
						// '-webkit-box-shadow': '0 0 5px rgba(0, 0, 0, 1)',
						// 'box-shadow': '0 0 5px rgba(0, 0, 0, 1)',
						'-webkit-transition': 'all 0.1s',
						'transition': 'all 0.1s'
			    	},
		    	cssQT : {
			    		'background-color': '#fff',
						'height': '100%',
						'width': '0',
						'position': 'relative',
						'z-index': '50',
						'-webkit-transition': 'all 0.1s',
						'transition': 'all 0.1s'
					},
		    	cssBar : {
			    		'position': 'absolute',
						'height': '2px',
						'width': '100%',
						'cursor': 'pointer',
						'top': '50%',
						'margin-top': '-6px',
						'padding': '5px 0'
			    	},
			   	cssBg : {
				   		'background-color': 'rgba(255,255,255,0.4)',
						'position': 'absolute',
						'height': '2px',
						'width': '100%',
						'top': '50%',
						'margin-top': '-1px',
						'z-index': '49'
				   	},
		    	ini : 0,
	            callbackOnChange : function(){}
	        }, options );

		if(settings.genTag){
			this.html(content);
		}
		sliderHL = $(settings.hlSelecter, this);
		sliderQT = $(settings.qtSelecter, this);
		sliderBar = $(settings.barSelecter, this);
		sliderBg = $(settings.bgSelecter, this);

		if(settings.genTag){
			sliderHL.css(settings.cssHL);
			sliderQT.css(settings.cssQT);
			sliderBar.css(settings.cssBar);
			sliderBg.css(settings.cssBg);
		}

		if(settings.percent > 0){
			changeSlider(settings.percent);
		}

		sliderBar.mousedown(function(){
			sliderIsMove = true;
			// $this.using = true;
		});

		sliderBar.click(function(e){
			var parentOffset = $(this).parent().offset(),
				relX = e.pageX - parentOffset.left,
			   	relY = e.pageY - parentOffset.top,
			   	width = $(this).width(),
			   	percent = (relX)*100/width;

			// percent = Math.round(percent);

			sliderHL.css({left : percent+'%'});
			sliderQT.css({width: percent+'%'});

			settings.callbackOnChange(percent);
		});

		$(document).mouseup(function(e){
			sliderIsMove = false;
		});

		$(document).mousemove(function(e){
			if(sliderIsMove){
				var offset = sliderBar.offset(),
					relX = e.pageX - offset.left,
				   	relY = e.pageY - offset.top,
				   	width = sliderBar.width(),
				   	percent;

				if(relX < 0){
					relX = 0;
				}else if(relX > width){
					relX = width;
				}

				percent = (relX*100/width);
				// percent = Math.round(percent);

				sliderHL.css({'left' : percent +'%'});
				sliderQT.css({'width': percent +'%'});

				settings.callbackOnChange(percent);

				e.preventDefault();
			}
		});

		function changeSlider(percent){
			if(!sliderIsMove && percent >= 0 && percent <= 100){
				sliderHL.css({left : percent+'%'});
				sliderQT.css({width: percent+'%'});
			}
		}

		return {
			changeSlider:function (percent){
				changeSlider(percent);
			}
		}
	};
}( jQuery ));